diff -r 4c693b4704d9 trytond/modules/party_vcarddav/webdav.py
--- a/trytond/modules/party_vcarddav/webdav.py	Tue Jul 31 09:18:55 2012 +0000
+++ b/trytond/modules/party_vcarddav/webdav.py	Mon Sep 24 20:36:41 2012 +0200
@@ -1,53 +1,56 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level of
 #this repository contains the full copyright notices and license terms.
 from pywebdav.lib.errors import DAV_NotFound, DAV_Forbidden
-from trytond.model import ModelView, ModelSQL
 from trytond.tools import reduce_ids
 from trytond.transaction import Transaction
 from trytond.cache import Cache
-from trytond.pool import Pool
+from trytond.pool import Pool, PoolMeta
+
+__all__ = ['Collection']
+__metaclass__ = PoolMeta
 
 
 CARDDAV_NS = 'urn:ietf:params:xml:ns:carddav'
 
 
-class Collection(ModelSQL, ModelView):
+class Collection:
+    __name__ = "webdav.collection"
+    _vcard_cache = Cache('webdav.collection.vcard', context=False)
 
-    _name = "webdav.collection"
-
-    @Cache('webdav_collection.vcard')
-    def vcard(self, uri):
+    @classmethod
+    def vcard(cls, uri):
         '''
         Return party ids of the vcard in uri or False
-
-        :param uri: the uri
-        :return: party id
-            or None if there is no party
-            or False if not in Contacts
         '''
-        party_obj = Pool().get('party.party')
+        Party = Pool().get('party.party')
+        party_id = cls._vcard_cache.get(uri, -1)
+        if party_id != -1:
+            return party_id
 
         if uri and uri.startswith('Contacts/'):
             uuid = uri[9:-4]
-            party_ids = party_obj.search([
-                ('uuid', '=', uuid),
-                ], limit=1)
-            if party_ids:
-                return party_ids[0]
-            return None
-        if uri == 'Contacts':
-            return None
-        return False
+            parties = Party.search([
+                    ('uuid', '=', uuid),
+                    ], limit=1)
+            if parties:
+                party_id = parties[0].id
+            else:
+                party_id = None
+        elif uri == 'Contacts':
+            party_id = None
+        else:
+            party_id = False
+        cls._vcard_cache.set(uri, party_id)
+        return party_id
 
-    def _carddav_filter_domain(self, filter):
+    @classmethod
+    def _carddav_filter_domain(cls, filter):
         '''
         Return a domain for the carddav filter
-
-        :param filter: the DOM Element of filter
-        :return: a list for domain
         '''
-        address_obj = Pool().get('party.address')
-        contact_mechanism_obj = Pool().get('party.contact_mechanism')
+        pool = Pool()
+        Address = pool.get('party.address')
+        ContactMechanism = pool.get('party.contact_mechanism')
 
         res = []
         if not filter:
@@ -110,60 +113,64 @@
                             res2.append((field, 'not ilike', value))
                     if name == 'adr':
                         domain = res2
-                        address_ids = address_obj.search(domain)
-                        res = [('addresses', 'in', address_ids)]
+                        addresses = Address.search(domain)
+                        res = [('addresses', 'in', [a.id for a in addresses])]
                     elif name in ('mail', 'tel'):
                         if name == 'mail':
                             type = ['email']
                         else:
                             type = ['phone', 'mobile']
                         domain = [('type', 'in', type), res2]
-                        contact_mechanism_ids = contact_mechanism_obj.search(
-                                domain)
+                        contact_mechanisms = ContactMechanism.search(
+                            domain)
                         res2 = [
-                            ('contact_mechanisms', 'in', contact_mechanism_ids)
+                            ('contact_mechanisms', 'in',
+                                [c.id for c in contact_mechanisms])
                             ]
                     res.append(res2)
         return res
 
-    def get_childs(self, uri, filter=None, cache=None):
-        party_obj = Pool().get('party.party')
+    @classmethod
+    def get_childs(cls, uri, filter=None, cache=None):
+        Party = Pool().get('party.party')
 
         if uri in ('Contacts', 'Contacts/'):
-            domain = self._carddav_filter_domain(filter)
-            party_ids = party_obj.search(domain)
-            parties = party_obj.browse(party_ids)
+            domain = cls._carddav_filter_domain(filter)
+            parties = Party.search(domain)
             if cache is not None:
                 cache.setdefault('_contact', {})
-                for party_id in party_ids:
-                    cache['_contact'][party_id] = {}
+                for party in parties:
+                    cache['_contact'][party.id] = {}
             return [x.uuid + '.vcf' for x in parties]
-        party_id = self.vcard(uri)
+        party_id = cls.vcard(uri)
         if party_id or party_id is None:
             return []
-        res = super(Collection, self).get_childs(uri, filter=filter,
+        res = super(Collection, cls).get_childs(uri, filter=filter,
                 cache=cache)
         if not uri and not filter:
             res.append('Contacts')
         return res
 
-    def get_resourcetype(self, uri, cache=None):
+    @classmethod
+    def get_resourcetype(cls, uri, cache=None):
         from DAV.constants import COLLECTION, OBJECT
-        party_id = self.vcard(uri)
+        party_id = cls.vcard(uri)
         if party_id:
             return OBJECT
         elif party_id is None:
             return COLLECTION
-        return super(Collection, self).get_resourcetype(uri, cache=cache)
+        return super(Collection, cls).get_resourcetype(uri, cache=cache)
 
-    def get_contenttype(self, uri, cache=None):
-        if self.vcard(uri):
+    @classmethod
+    def get_contenttype(cls, uri, cache=None):
+        if cls.vcard(uri):
             return 'text/x-vcard'
-        return super(Collection, self).get_contenttype(uri, cache=cache)
+        return super(Collection, cls).get_contenttype(uri, cache=cache)
 
-    def get_creationdate(self, uri, cache=None):
-        party_obj = Pool().get('party.party')
-        party_id = self.vcard(uri)
+    @classmethod
+    def get_creationdate(cls, uri, cache=None):
+        Party = Pool().get('party.party')
+        party_id = cls.vcard(uri)
 
         cursor = Transaction().cursor
 
@@ -185,7 +192,7 @@
                 red_sql, red_ids = reduce_ids('id', sub_ids)
                 cursor.execute('SELECT id, ' \
                             'EXTRACT(epoch FROM create_date) ' \
-                        'FROM "' + party_obj._table + '" ' \
+                        'FROM "' + Party._table + '" ' \
                         'WHERE ' + red_sql, red_ids)
                 for party_id2, date in cursor.fetchall():
                     if party_id2 == party_id:
@@ -195,17 +202,18 @@
                         cache['_contact'][party_id2]['creationdate'] = date
             if res is not None:
                 return res
-        return super(Collection, self).get_creationdate(uri, cache=cache)
+        return super(Collection, cls).get_creationdate(uri, cache=cache)
 
-    def get_lastmodified(self, uri, cache=None):
+    @classmethod
+    def get_lastmodified(cls, uri, cache=None):
         pool = Pool()
-        party_obj = pool.get('party.party')
-        address_obj = pool.get('party.address')
-        contact_mechanism_obj = pool.get('party.contact_mechanism')
+        Party = pool.get('party.party')
+        Address = pool.get('party.address')
+        ContactMechanism = pool.get('party.contact_mechanism')
 
         cursor = Transaction().cursor
 
-        party_id = self.vcard(uri)
+        party_id = cls.vcard(uri)
         if party_id:
             if cache is not None:
                 cache.setdefault('_contact', {})
@@ -227,10 +235,10 @@
                             'COALESCE(a.write_date, a.create_date))), '
                         'MAX(EXTRACT(epoch FROM '
                             'COALESCE(c.write_date, c.create_date))) '
-                    'FROM "' + party_obj._table + '" p '
-                    'LEFT JOIN "' + address_obj._table + '" a '
+                    'FROM "' + Party._table + '" p '
+                    'LEFT JOIN "' + Address._table + '" a '
                         'ON p.id = a.party '
-                    'LEFT JOIN "' + contact_mechanism_obj._table + '" c '
+                    'LEFT JOIN "' + ContactMechanism._table + '" c '
                         'ON p.id = c.party '
                     'WHERE ' + red_sql + ' '
                     'GROUP BY p.id', red_ids)
@@ -243,93 +251,98 @@
                         cache['_contact'][party_id2]['lastmodified'] = date
             if res is not None:
                 return res
-        return super(Collection, self).get_lastmodified(uri, cache=cache)
+        return super(Collection, cls).get_lastmodified(uri, cache=cache)
 
-    def get_data(self, uri, cache=None):
-        vcard_obj = Pool().get('party_vcarddav.party.vcard', type='report')
-        party_id = self.vcard(uri)
+    @classmethod
+    def get_data(cls, uri, cache=None):
+        Vcard = Pool().get('party_vcarddav.party.vcard', type='report')
+        party_id = cls.vcard(uri)
         if party_id is None:
             raise DAV_NotFound
         if party_id:
-            val = vcard_obj.execute([party_id],
-                    {'id': party_id, 'ids': [party_id]},
-                    )
+            val = Vcard.execute([party_id],
+                {'id': party_id, 'ids': [party_id]})
             return val[1]
-        return super(Collection, self).get_data(uri, cache=cache)
+        return super(Collection, cls).get_data(uri, cache=cache)
 
-    def get_address_data(self, uri, cache=None):
-        vcard_obj = Pool().get('party_vcarddav.party.vcard', type='report')
-        party_id = self.vcard(uri)
+    @classmethod
+    def get_address_data(cls, uri, cache=None):
+        Vcard = Pool().get('party_vcarddav.party.vcard', type='report')
+        party_id = cls.vcard(uri)
         if not party_id:
             raise DAV_NotFound
-        return vcard_obj.execute([party_id],
+        return Vcard.execute([party_id],
             {'id': party_id, 'ids': [party_id]},
             ).decode('utf-8')
 
-    def put(self, uri, data, content_type, cache=None):
+    @classmethod
+    def put(cls, uri, data, content_type, cache=None):
         import vobject
-        party_obj = Pool().get('party.party')
+        Party = Pool().get('party.party')
 
-        party_id = self.vcard(uri)
+        party_id = cls.vcard(uri)
         if party_id is None:
             vcard = vobject.readOne(data)
-            values = party_obj.vcard2values(None, vcard)
+            values = Party().vcard2values(vcard)
             try:
-                party_id = party_obj.create(values)
+                party_id = Party.create(values)
             except Exception:
                 raise DAV_Forbidden
-            party = party_obj.browse(party_id)
+            party = Party(party_id)
             return (Transaction().cursor.database_name + '/Contacts/' +
                     party.uuid + '.vcf')
         if party_id:
+            party = Party(party_id)
             vcard = vobject.readOne(data)
-            values = party_obj.vcard2values(party_id, vcard)
+            values = party.vcard2values(vcard)
             try:
-                party_obj.write(party_id, values)
+                Party.write([party], values)
             except Exception:
                 raise DAV_Forbidden
             return
-        return super(Collection, self).put(uri, data, content_type,
+        return super(Collection, cls).put(uri, data, content_type,
             cache=cache)
 
-    def mkcol(self, uri, cache=None):
-        party_id = self.vcard(uri)
+    @classmethod
+    def mkcol(cls, uri, cache=None):
+        party_id = cls.vcard(uri)
         if party_id is None:
             raise DAV_Forbidden
         if party_id:
             raise DAV_Forbidden
-        return super(Collection, self).mkcol(uri, cache=cache)
+        return super(Collection, cls).mkcol(uri, cache=cache)
 
-    def rmcol(self, uri, cache=None):
-        party_id = self.vcard(uri)
+    @classmethod
+    def rmcol(cls, uri, cache=None):
+        party_id = cls.vcard(uri)
         if party_id is None:
             raise DAV_Forbidden
         if party_id:
             raise DAV_Forbidden
-        return super(Collection, self).rmcol(uri, cache=cache)
+        return super(Collection, cls).rmcol(uri, cache=cache)
 
-    def rm(self, uri, cache=None):
-        party_obj = Pool().get('party.party')
+    @classmethod
+    def rm(cls, uri, cache=None):
+        Party = Pool().get('party.party')
 
-        party_id = self.vcard(uri)
+        party_id = cls.vcard(uri)
         if party_id is None:
             raise DAV_Forbidden
         if party_id:
             try:
-                party_obj.delete(party_id)
+                Party.delete([Party(party_id)])
             except Exception:
                 raise DAV_Forbidden
             return 200
-        return super(Collection, self).rm(uri, cache=cache)
+        return super(Collection, cls).rm(uri, cache=cache)
 
-    def exists(self, uri, cache=None):
-        party_id = self.vcard(uri)
+    @classmethod
+    def exists(cls, uri, cache=None):
+        party_id = cls.vcard(uri)
         if party_id is None or party_id:
             if party_id:
                 return 1
             if uri in ('Contacts', 'Contacts/'):
                 return 1
             return 0
-        return super(Collection, self).exists(uri, cache=cache)
-
-Collection()
+        return super(Collection, cls).exists(uri, cache=cache)
diff -r 73af8be8415d trytond/modules/product/__init__.py
--- a/trytond/modules/product/__init__.py	Thu Aug 23 23:18:16 2012 +0200
+++ b/trytond/modules/product/__init__.py	Mon Sep 24 20:36:41 2012 +0200
@@ -1,6 +1,17 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level of
 #this repository contains the full copyright notices and license terms.
 
+from trytond.pool import Pool
 from .uom import *
 from .category import *
 from .product import *
+
+
+def register():
+    Pool.register(
+        UomCategory,
+        Uom,
+        Category,
+        Template,
+        Product,
+        module='product', type_='model')
diff -r 73af8be8415d trytond/modules/product/category.py
--- a/trytond/modules/product/category.py	Thu Aug 23 23:18:16 2012 +0200
+++ b/trytond/modules/product/category.py	Mon Sep 24 20:36:41 2012 +0200
@@ -2,42 +2,32 @@
 #this repository contains the full copyright notices and license terms.
 from trytond.model import ModelView, ModelSQL, fields
 
+__all__ = ['Category']
+
 
 class Category(ModelSQL, ModelView):
     "Product Category"
-    _name = "product.category"
-    _description = __doc__
-
+    __name__ = "product.category"
     name = fields.Char('Name', required=True, translate=True)
     parent = fields.Many2One('product.category', 'Parent', select=True)
     childs = fields.One2Many('product.category', 'parent',
             string='Children')
 
-    def __init__(self):
-        super(Category, self).__init__()
-        self._order.insert(0, ('name', 'ASC'))
+    @classmethod
+    def __setup__(cls):
+        super(Category, cls).__setup__()
+        cls._order.insert(0, ('name', 'ASC'))
 
-        self._constraints += [
+        cls._constraints += [
             ('check_recursion', 'recursive_categories'),
-        ]
-        self._error_messages.update({
-            'recursive_categories': 'You can not create recursive categories!',
-        })
+            ]
+        cls._error_messages.update({
+                'recursive_categories': \
+                    'You can not create recursive categories!',
+                })
 
-    def get_rec_name(self, ids, name):
-        if not ids:
-            return {}
-        res = {}
-
-        def _name(category):
-            if category.id in res:
-                return res[category.id]
-            elif category.parent:
-                return _name(category.parent) + ' / ' + category.name
-            else:
-                return category.name
-        for category in self.browse(ids):
-            res[category.id] = _name(category)
-        return res
-
-Category()
+    def get_rec_name(self, name):
+        if self.parent:
+            return self.parent.get_rec_name(name) + ' / ' + self.name
+        else:
+            return self.name
diff -r 73af8be8415d trytond/modules/product/product.py
--- a/trytond/modules/product/product.py	Thu Aug 23 23:18:16 2012 +0200
+++ b/trytond/modules/product/product.py	Mon Sep 24 20:36:41 2012 +0200
@@ -6,6 +6,8 @@
 from trytond.pool import Pool
 from trytond.backend import TableHandler
 
+__all__ = ['Template', 'Product']
+
 STATES = {
     'readonly': ~Eval('active', True),
     }
@@ -14,9 +16,7 @@
 
 class Template(ModelSQL, ModelView):
     "Product Template"
-    _name = "product.template"
-    _description = __doc__
-
+    __name__ = "product.template"
     name = fields.Char('Name', size=None, required=True, translate=True,
         select=True, states=STATES, depends=DEPENDS)
     type = fields.Selection([
@@ -50,146 +50,122 @@
     default_uom_category = fields.Function(
         fields.Many2One('product.uom.category', 'Default UOM Category',
             on_change_with=['default_uom']),
-        'get_default_uom_category')
+        'on_change_with_default_uom_category')
     active = fields.Boolean('Active', select=True)
     products = fields.One2Many('product.product', 'template', 'Products',
         states=STATES, depends=DEPENDS)
 
-    def init(self, module_name):
+    @classmethod
+    def __register__(cls, module_name):
         cursor = Transaction().cursor
 
-        super(Template, self).init(module_name)
+        super(Template, cls).__register__(module_name)
 
-        table = TableHandler(cursor, self, module_name)
+        table = TableHandler(cursor, cls, module_name)
         # Migration from 2.2: category is no more required
         table.not_null_action('category', 'remove')
 
         # Migration from 2.2: new types
-        cursor.execute('UPDATE "' + self._table + '" '
+        cursor.execute('UPDATE "' + cls._table + '" '
             'SET consumable = %s WHERE type = %s', (True, 'consumable'))
-        cursor.execute('UPDATE "' + self._table + '" '
+        cursor.execute('UPDATE "' + cls._table + '" '
             'SET type = %s WHERE type IN (%s, %s)',
             ('goods', 'stockable', 'consumable'))
 
-    def default_active(self):
+    @staticmethod
+    def default_active():
         return True
 
-    def default_type(self):
+    @staticmethod
+    def default_type():
         return 'goods'
 
-    def default_consumable(self):
+    @staticmethod
+    def default_consumable():
         return False
 
-    def default_cost_price_method(self):
+    @staticmethod
+    def default_cost_price_method():
         return 'fixed'
 
-    def on_change_with_default_uom_category(self, values):
-        pool = Pool()
-        uom_obj = pool.get('product.uom')
-        if values.get('default_uom'):
-            uom = uom_obj.browse(values['default_uom'])
-            return uom.category.id
+    def on_change_with_default_uom_category(self, name=None):
+        if self.default_uom:
+            return self.default_uom.category.id
 
-    def get_default_uom_category(self, ids, name):
-        categories = {}
-        for template in self.browse(ids):
-            categories[template.id] = template.default_uom.category.id
-        return categories
-
-    def get_price_uom(self, ids, name):
-        product_uom_obj = Pool().get('product.uom')
+    @staticmethod
+    def get_price_uom(products, name):
+        Uom = Pool().get('product.uom')
         res = {}
         field = name[:-4]
         if Transaction().context.get('uom'):
-            to_uom = product_uom_obj.browse(
-                Transaction().context['uom'])
-            for product in self.browse(ids):
-                res[product.id] = product_uom_obj.compute_price(
-                        product.default_uom, product[field], to_uom)
+            to_uom = Uom(Transaction().context['uom'])
+            for product in products:
+                res[product.id] = Uom.compute_price(
+                    product.default_uom, getattr(product, field), to_uom)
         else:
-            for product in self.browse(ids):
-                res[product.id] = product[field]
+            for product in products:
+                res[product.id] = getattr(product, field)
         return res
 
-    def copy(self, ids, default=None):
+    @classmethod
+    def copy(cls, templates, default=None):
         if default is None:
             default = {}
         default = default.copy()
         default['products'] = None
-        return super(Template, self).copy(ids, default=default)
-
-Template()
+        return super(Template, cls).copy(templates, default=default)
 
 
 class Product(ModelSQL, ModelView):
     "Product"
-    _name = "product.product"
-    _description = __doc__
+    __name__ = "product.product"
     _inherits = {'product.template': 'template'}
-
     template = fields.Many2One('product.template', 'Product Template',
             required=True, ondelete='CASCADE', select=True)
     code = fields.Char("Code", size=None, select=True)
     description = fields.Text("Description", translate=True)
 
-    def get_rec_name(self, ids, name):
-        if not ids:
-            return {}
-        res = {}
-        for product in self.browse(ids):
-            name = product.name
-            if product.code:
-                name = '[' + product.code + '] ' + product.name
-            res[product.id] = name
-        return res
+    def get_rec_name(self, name):
+        if self.code:
+            return '[' + self.code + '] ' + self.name
+        else:
+            return self.name
 
-    def search_rec_name(self, name, clause):
-        ids = self.search([('code',) + clause[1:]], order=[])
+    @classmethod
+    def search_rec_name(cls, name, clause):
+        ids = map(int, cls.search([('code',) + clause[1:]], order=[]))
         if ids:
-            ids += self.search([('name',) + clause[1:]], order=[])
+            ids += map(int, cls.search([('name',) + clause[1:]], order=[]))
             return [('id', 'in', ids)]
         return [('name',) + clause[1:]]
 
-    def delete(self, ids):
-        template_obj = Pool().get('product.template')
-
-        if isinstance(ids, (int, long)):
-            ids = [ids]
+    @classmethod
+    def delete(cls, products):
+        Template = Pool().get('product.template')
 
         # Get the templates before we delete the products.
-        products = self.browse(ids)
-        template_ids = [product.template.id for product in products]
+        templates = [product.template for product in products]
 
-        res = super(Product, self).delete(ids)
+        super(Product, cls).delete(products)
 
         # Get templates that are still linked after delete.
-        templates = template_obj.browse(template_ids)
-        unlinked_template_ids = [template.id for template in templates \
-                                 if not template.products]
-        if unlinked_template_ids:
-            template_obj.delete(unlinked_template_ids)
+        unlinked_templates = [template for template in templates
+            if not template.products]
+        if unlinked_templates:
+            Template.delete(unlinked_templates)
 
-        return res
+    @classmethod
+    def copy(cls, products, default=None):
+        Template = Pool().get('product.template')
 
-    def copy(self, ids, default=None):
-        template_obj = Pool().get('product.template')
-
-        int_id = False
-        if isinstance(ids, (int, long)):
-            int_id = True
-            ids = [ids]
         if default is None:
             default = {}
         default = default.copy()
         default['products'] = None
-        new_ids = []
-        for product in self.browse(ids):
-            default['template'] = template_obj.copy(product.template.id)
-            new_id = super(Product, self).copy(product.id, default=default)
-            new_ids.append(new_id)
-
-        if int_id:
-            return new_ids[0]
-        return new_ids
-
-Product()
+        new_products = []
+        for product in products:
+            template, = Template.copy([product.template])
+            default['template'] = template.id
+            new_products.extend(super(Product, cls).copy([product],
+                    default=default))
+        return new_products
